/*
 * comm.c
 *
 * Created: 2015/04/10 13:01:11
 *  Author: NTAKA
 */ 

#include "std.h"

#include <avr/pgmspace.h>

#include <string.h>
#include <stdlib.h>

#include "usart.h"
#include "cmd_parser.h"

// I[ CR + LF
#define CR	0x0d
#define LF	0x0a

// /////////////////////////////////////////
// ֐錾
void push_queue(enum COMMAND cmd, const char *char_data);
int strcmp_cmd(const char* str, PGM_P cmd);
int push_charbuf(char c);

// /////////////////////////////////////////
// R}h`

const char PROGMEM CMD01_[] = { 'G', 'R', CR, LF, '\0' };
const char PROGMEM CMD02_[] = { 'G', 'G', CR, LF, '\0' };
const char PROGMEM CMD03_[] = { 'G', 'B', CR, LF, '\0' };

const char PROGMEM CMD04_[] = { 'S', 'R', '\t', '\t', CR, LF, '\0' };
const char PROGMEM CMD05_[] = { 'S', 'G', '\t', '\t', CR, LF, '\0' };
const char PROGMEM CMD06_[] = { 'S', 'B', '\t', '\t', CR, LF, '\0' };
	
const char PROGMEM CMD07_[] = { 'S', 'D', '\t', '\t', ',', '\t', '\t', ',',  '\t', '\t', CR, LF, '\0' };
const char PROGMEM CMD08_[] = { 'G', 'D', CR, LF, '\0' };
	
const char PROGMEM CMD09_[] = { 'G', 'M', CR, LF, '\0' };
const char PROGMEM CMD10_[] = { 'S', 'M', '\t', CR, LF, '\0' };

const char PROGMEM CMD11_[] = { 'G', 'P', CR, LF, '\0' };
	
const char PROGMEM CMD12_[] = { 'S', 'S', '\t', CR, LF, '\0' };
const char PROGMEM CMD13_[] = { 'G', 'S', CR, LF, '\0' };
	
const char PROGMEM CMD20_[] = { 'S', 'V', CR, LF, '\0' };
const char PROGMEM CMD21_[] = { 'L', 'D', CR, LF, '\0' };
const char PROGMEM CMD22_[] = { 'D', 'T', CR, LF, '\0' };
const char PROGMEM CMD23_[] = { 'R', 'T', CR, LF, '\0' };

// /////////////////////////////////////////
// M񏈗obt@\
#define CHAR_BUF_SIZE_	24			// Mobt@TCY

typedef struct tagCHARBUF
{
	char buf[CHAR_BUF_SIZE_ + 1];	// obt@(I[ \0 ǉ\̂ +1)
	int wpos;						// ݂writeʒu(݃CfbNX)
	int cr_flag;					// I[Jn CR M̃tO
} CHARBUF;

// /////////////////////////////////////////
// R}hL[\
#define QUEUE_BUF_SIZE_			8		// R}hL[̃TCY

typedef struct tagQUEUEBUF
{
	char char_buf[QUEUE_BUF_SIZE_][CHAR_BUF_SIZE_ + 1];	// Mۑobt@
	enum COMMAND buf[QUEUE_BUF_SIZE_];				// obt@
	
	int wpos;	// ݂writeʒu(݃CfbNX)
	int rpos;	// ݂readʒu(Ǎ݃CfbNX)
} QUEUEBUF;

CHARBUF g_charbuf;
QUEUEBUF g_cmdqueue;


//-----------------------------------------------------------
// R}hp[T
//-----------------------------------------------------------
void cmd_init(unsigned int baud)
{
	g_charbuf.wpos = g_charbuf.cr_flag = 0;
	g_cmdqueue.rpos = g_cmdqueue.wpos = 0;
	
	// USART
	uart_init(baud);
}

//-----------------------------------------------------------
// R}hL[|bvł邩𒲂ׂi|bv\Ŕ0j
//-----------------------------------------------------------
int cmd_is_pop_queue()
{
	return (g_cmdqueue.rpos == g_cmdqueue.wpos) ? 0 : 1;
}

//-----------------------------------------------------------
// L[R}h|bv
// |bvf[^Ȃꍇ CMD_NONE ԂB
//-----------------------------------------------------------
enum COMMAND cmd_pop_queue()
{
	if(cmd_is_pop_queue() == 0)
		return CMD_NONE;
	
	enum COMMAND cmd = g_cmdqueue.buf[g_cmdqueue.rpos++];
	
	if(g_cmdqueue.rpos >= QUEUE_BUF_SIZE_)
		g_cmdqueue.rpos = 0;
	
	return cmd;
}

//-----------------------------------------------------------
// L[R}hM܂߂ă|bv
// |bvf[^Ȃꍇ CMD_NONE@A
// char_buf ɂ "" ̕ԂB
//
// char_buf : MԂobt@(TCY 17 ȏ)
//-----------------------------------------------------------
enum COMMAND cmd_pop_queue_all(char* char_buf)
{
	if(cmd_is_pop_queue() == 0)
	{
		char_buf[0] = '\0';
		return CMD_NONE;
	}
	
	enum COMMAND cmd = g_cmdqueue.buf[g_cmdqueue.rpos];
	strcpy(char_buf, g_cmdqueue.char_buf[g_cmdqueue.rpos]);
	
	g_cmdqueue.rpos++;
	
	if(g_cmdqueue.rpos >= QUEUE_BUF_SIZE_)
		g_cmdqueue.rpos = 0;
	
	return cmd;
}

//-----------------------------------------------------------
// UART 當ǂݍ݃R}h͂sB
// 
// ߂l
// 0 : R}h͌p
// 1 : ǂݍݒɐVR}hvbVꂽ
// 2 : ^CAEg
//-----------------------------------------------------------
int cmd_paese_from_uart()
{
	int res = 0;
	
	// obt@ɂ邾M
	while(uart_is_received())
	{
		if(push_charbuf(uart_recv_byte()))
		{
			res = 1;
		}
	}
	
	return res;
}


//-----------------------------------------------------------
// p[T̕obt@󂩂𒲂ׂ
// 
// <߂l>
// 0 : ł͂Ȃi͒̕񂪑݂j
// 1 : łi͒͂̕Ȃj
//-----------------------------------------------------------
int cmd_is_empty()
{
	return (g_charbuf.wpos == 0) ? 1 : 0;
}

//-----------------------------------------------------------
// UART ŃbZ[W𑗐MiI[ CR+LF ͎ŕtj
//
// str    : MbZ[W
// sufix  : M̍ŏɕt
//			SEND_STR_SUFIX_NONE : Ȃ
//			SEND_STR_SUFIX_OK   : "OK,"
//			SEND_STR_SUFIX_NG   : "NG,"
//-----------------------------------------------------------
void cmd_send_str_uart(const char* str, int sufix)
{
	char buf[64];
	
	int i = 0;
	
	if(sufix == SEND_STR_SUFIX_OK)
	{
		buf[i++] = 'O';
		buf[i++] = 'K';
		buf[i++] = ',';
	}
	else if(sufix == SEND_STR_SUFIX_NG)
	{
		buf[i++] = 'N';
		buf[i++] = 'G';
		buf[i++] = ',';
	}
	
	while(*str)
	{
		buf[i++] = *str++;
	}
	
	buf[i++] = CR;
	buf[i++] = LF;
	buf[i] = '\0';
	
	uart_send_string(buf);
}

//-----------------------------------------------------------
// UART ŃbZ[W𑗐MiI[ CR+LF ͎ŕtj
//
// str    : MbZ[W
// sufix  : M̍ŏɕt
//			SEND_STR_SUFIX_NONE : Ȃ
//			SEND_STR_SUFIX_OK   : "OK,"
//			SEND_STR_SUFIX_NG   : "NG,"
//-----------------------------------------------------------
void cmd_send_str_uart_P(PGM_P str, int sufix)
{
	char buf[64];
	
	int i = 0;
	
	if(sufix == SEND_STR_SUFIX_OK)
	{
		buf[i++] = 'O';
		buf[i++] = 'K';
		buf[i++] = ',';
	}
	else if(sufix == SEND_STR_SUFIX_NG)
	{
		buf[i++] = 'N';
		buf[i++] = 'G';
		buf[i++] = ',';
	}
	
	
	int q = 0;
	
	while(1)
	{
		char c = pgm_read_byte(&str[q++]);
		
		if(c == '\0')
		break;
		
		buf[i++] = c;
	}
	
	buf[i++] = CR;
	buf[i++] = LF;
	buf[i] = '\0';
	
	uart_send_string(buf);
}















//-----------------------------------------------------------
// L[փvbV
//-----------------------------------------------------------
void push_queue(enum COMMAND cmd, const char *char_data)
{
	g_cmdqueue.buf[g_cmdqueue.wpos] = cmd;
	strcpy(g_cmdqueue.char_buf[g_cmdqueue.wpos], char_data);
	
	g_cmdqueue.wpos++;
	
	if(g_cmdqueue.wpos >= QUEUE_BUF_SIZE_)
	g_cmdqueue.wpos = 0;
}

//-----------------------------------------------------------
// p[T̕obt@ 1ǉăR}h͂sB
//
// ߂l
// 0 : R}h͌p
// 1 : R}hvbVꂽ
//-----------------------------------------------------------
int push_charbuf(char c)
{
	g_charbuf.buf[g_charbuf.wpos] = c;
	
	// O CR ̏ꍇ
	if(g_charbuf.cr_flag)
	{
		// I[ LF Ȃ΁AR}hr
		if(c == LF)
		{
			g_charbuf.buf[g_charbuf.wpos + 1] = '\0';
			
			if(strcmp_cmd(g_charbuf.buf, CMD01_) == 0)
				push_queue(CMD_GET_R, g_charbuf.buf);
			else if(strcmp_cmd(g_charbuf.buf, CMD02_) == 0)
				push_queue(CMD_GET_G, g_charbuf.buf);
			else if(strcmp_cmd(g_charbuf.buf, CMD03_) == 0)
				push_queue(CMD_GET_B, g_charbuf.buf);
			
			
			else if(strcmp_cmd(g_charbuf.buf, CMD04_) == 0)
				push_queue(CMD_SET_R, g_charbuf.buf);
			else if(strcmp_cmd(g_charbuf.buf, CMD05_) == 0)
				push_queue(CMD_SET_G, g_charbuf.buf);
			else if(strcmp_cmd(g_charbuf.buf, CMD06_) == 0)
				push_queue(CMD_SET_B, g_charbuf.buf);
			
			else if(strcmp_cmd(g_charbuf.buf, CMD07_) == 0)
				push_queue(CMD_SET_DATA, g_charbuf.buf);
			else if(strcmp_cmd(g_charbuf.buf, CMD08_) == 0)
				push_queue(CMD_GET_DATA, g_charbuf.buf);
			
			else if(strcmp_cmd(g_charbuf.buf, CMD09_) == 0)
				push_queue(CMD_GET_PWM_MODE, g_charbuf.buf);
			else if(strcmp_cmd(g_charbuf.buf, CMD10_) == 0)
				push_queue(CMD_SET_PWM_MODE, g_charbuf.buf);
				
			else if(strcmp_cmd(g_charbuf.buf, CMD11_) == 0)
				push_queue(CMD_GET_PC_POWER, g_charbuf.buf);
				
			else if(strcmp_cmd(g_charbuf.buf, CMD12_) == 0)
				push_queue(CMD_SET_PWM_SW, g_charbuf.buf);
			else if(strcmp_cmd(g_charbuf.buf, CMD13_) == 0)
				push_queue(CMD_GET_PWM_SW, g_charbuf.buf);
			
			else if(strcmp_cmd(g_charbuf.buf, CMD20_) == 0)
				push_queue(CMD_SAVE, g_charbuf.buf);
			else if(strcmp_cmd(g_charbuf.buf, CMD21_) == 0)
				push_queue(CMD_LOAD, g_charbuf.buf);
			else if(strcmp_cmd(g_charbuf.buf, CMD22_) == 0)
				push_queue(CMD_DEFAULT, g_charbuf.buf);
			else if(strcmp_cmd(g_charbuf.buf, CMD23_) == 0)
				push_queue(CMD_RESET, g_charbuf.buf);
			
			else
				push_queue(CMD_UNKNOWN, g_charbuf.buf);
		}
		// CR ɂ炸ȊO̕ꍇ
		else
		{
			push_queue(CMD_ERROR, "");
		}
		
		g_charbuf.wpos = 0;
		g_charbuf.cr_flag = 0;
		
		return 1;
	}
	
	// I[̊Jn CR H
	if(c == CR)
	{
		g_charbuf.cr_flag = 1;
	}
	
	g_charbuf.wpos++;
	
	// obt@[I[o[H
	if(g_charbuf.wpos >= CHAR_BUF_SIZE_)
	{
		g_charbuf.wpos = 0;
		g_charbuf.cr_flag = 0;
		
		push_queue(CMD_ERROR, "");
		
		return 1;
	}

	return 0;
}

//-----------------------------------------------------------
// R}h̔r
//-----------------------------------------------------------
int strcmp_cmd(const char* str, PGM_P cmd)
{
	int i = 0;
	
	while(1)
	{
		char c1 = *str++;
		char c2 = pgm_read_byte(&cmd[i++]);
		
		if(c1 == 0 && c2 == 0)
		break;
		
		if(c1 == 0 || c2 == 0)
		return -1;
		
		if(c2 == '\t')
		continue;
		
		if(c1 != c2)
		return -1;
	}
	
	return 0;
}

